\chapter{Different perspectives on the Linux Kernel Development Model}
\label{cap:twoperspectives}

This chapter presents an up-to-date comprehensive description of the Linux
kernel community from different perspectives of FLOSS community publications,
Software Engineering studies, and Participant Observation. We compare concepts
from grey to traditional literatures in the last decade, and highlight
convergence and divergences on undestanding the current Linux kernel community
model. We directly participated in the development community routine to discuss our
findings and shed light on pitfalls in mistaken assumptions.

\section{Multivocal Literature Review}
\label{sec:mlrmethod}

In this research, we conducted a multivocal literature review to embrace the
concepts from the current Linux kernel development community theory and
practice. Multivocal literature can summarize both state-of-the-art and
-practice. The comparison between its findings also is fruitful to identify
gaps and conflicts between theory and practice in the comprehension of the
FLOSS phenomenon and its transformation, improving the conduction and
relevance of FLOSS research in software engineering.

In conducting a multivocal review, a researcher needs to consider the documents'
differences of structure standards, the rigor of the review, and how their
findings are supported. Due to the FLOSS continuous innovation characteristic,
software engineering researchers and practitioners may also not be at the same
pace. These incompatibilities can result in studies with outdated information
and also misunderstandings.

To overcome these diverse challenges, we opted for a research strategy based
on findings from GLR and subsequent correspondence with SLR codes. Therefore,
we reviewed the grey literature on FLOSS to find the Linux kernel development
community's state-of-practice and its convergence with the bazaar model, i.e.,
the open-source paradigm~\citep{Sanders1998}. We conducted a systematic
literature review and, for mapping congruences and incongruities, we analyzed
SLR data and compared their codes based on the GLR findings. 

%% ------------------------------------------------------------------------- %%
\subsection{Systematic Literature Review}
\label{sec:slrmethod}

This research phase aims to compare, using a systematic
literature review, the attributes used by Software Engineering studies to
characterize the current Linux development community model with those
systematized by the previous Grey Literature Review.

The primary studies were identified by querying digital libraries and following
a methodical protocol for study selection. Using a directed approach to content
analysis, we compare and extend conceptually the framework obtained from the
GL. The content analysis also exposed a certain lack of pace between
what is investigated in academic studies and the Linux kernel community
concerns.

\subsubsection{Studies Selection}

We design a systematic literature review protocol (Appendix~\ref{att:slrprotocol}) based
on recommendations from ~\citet{Biolchini2007, Kitchenham2009, Cochrane2008}.
From the problem outline that guides this research (Section~\ref{sec:problem}), the
systematic review aims to answer the software engineering studies perspectives
of \textit{RQ1. How do software engineering studies and Linux community publications describe the current Linux development community model?}

We selected documents from journals and peer-reviewed conferences available in
the following digital libraries:

\begin{itemize}
\item IEEExplore (\url{https://ieeexplore.ieee.or})
\item ACM Digital library  (\url{https://dl.acm.org/})
\item ScienceDirect/Elsevier (\url{www.sciencedirect.com})
\item Springer (\url{https://link.springer.com/})
\item Google scholar (\url{scholar.google.com}) [For double checking]
\end{itemize}

Traditional publishers and their standards for publication provide helpful
search engine tools. On the other hand, the Linux kernel is used in various
markets, and the system and its development project have characteristics
relevant to a wide range of interests in software engineering studies.
To mitigate inconsistency issues
in studies of Linux and increase the search-string efficiency, we tested the
accuracy of the same terms used in the GL search process by
performing several search iterations until reaching a search string with
synonyms and composed terms:

\textit{``Linux kernel'' AND (``development model'' OR ``community
practices'' OR ``development practices'' OR ``community rules'' OR
``development process'')}

As opposed to grey literature databases, digital libraries have a higher
quality of search engine and homogeneity in features and listing of search
hits. Consequently, we obtained a more efficient result from defining a
search string with composed terms, i.e., words combination. We considered the same
time interval of GLR to retrieve traditional publications (from 2009 to 2019+).
We applied the query mentioned above in four databases in March 2020, as
shown in Table~\ref{tab:slr_database}, and obtained a total of 1081
candidate-documents.

\begin{table}[]
\centering
\caption{Search string results per digital library}
\label{tab:slr_database}
\resizebox{0.6\textwidth}{!}{%
\begin{tabular}{lll}
	\rowcolor[HTML]{c0d6e4}
	\hline
Database & \# of hits & \# of duplicated \\ \hline
IEEExplore & 96 & 3 \\
ACM Digital Library & 335 & 27 \\
Science Direct & 203 & 5 \\
Springer & 447 & 6
\end{tabular}%
}
\end{table}

Table~\ref{tab:slr_database} summarized the number of documents obtained from
each digital library. These repositories enable us to filter only online avaliable
documents written in English; therefore, we had no effort to evaluate the
compliance of this first two eligibility criteria, as defined in our SLR
protocol, in Appendix \ref{att:slrprotocol}.
Whenever possible, we downloaded the reference hits as CSV or Bibtex files.
We stored the references lists on the Mendeley tool to facilitate metadata
evaluation. After, we transposed the gathered references to an online spreadsheet
on Google for documenting the entire screening process.
Using the Mendeley's feature of ``Check for Duplicates'', we found 41 duplicated
documents, marking them as duplicated in the spreadsheet for exclusion.

\subsubsection{Identification and Screening Process}

Before starting the screening process, we classified the publication venue
according to its context relevance for software engineering and FLOSS studies, as
shown in Table~\ref{tab:slr_database_pub}.

\begin{table}[]
\centering
\caption{First step - Evaluating publication}
\label{tab:slr_database_pub}
\resizebox{1.0\textwidth}{!}{%
\begin{tabular}{m{2cm}m{5cm}m{9cm}}
\hline
\rowcolor[HTML]{a6cee3} 
\multicolumn{1}{l}{\cellcolor[HTML]{a6cee3}Publication level} & Meaning & Criteria \\ \hline
-1 & Excluded: Out of context & Publication venue and Publication keywords \\ \hline
0 & Excluded: Out of interest & Book chapter and Less than 10 pages \\ \hline
2 & Less Priority & Magazines \\ \hline
3 & High Priority & Journals and Conferences paper with more than 10 pages or focused on FLOSS \\ \hline
* & Unclear & \\ \hline
\end{tabular}%
}
\end{table}

From this classification, we identified publications in FLOSS and Software
Engineering topics more likely to meet our eligibility criteria with stronger
findings. We excluded 677 documents in this classification step.
To the next step of screening, we selected 363 documents with more than 10
pages published in journal and conferences on FLOSS and SE research venue.

Reviewer 1, the leading researcher of this work, performed the initial phase of the screening process to
exclude documents by title that clearly meets at least one exclusion
criteria. She excluded 173 documents because their title are
clearly out of the context of this research. Even though \citet{Cochrane2008}
recommend the participation of two or more reviewers in the screening process,
a single reviewer in the initial step is acceptable.

At this point, we conducted a participant-observation in the Linux kernel
project, and Reviewer 1 became a member of the project development community.
We also introduced a second reviewer for the first round of text evaluation.
Here, we identified this reviewer as Reviewer 3 since this one is a different
person than Reviewer 2, who participated in the GLR screening process.
Different from Reviewer 2, Reviewer 3 is not a Linux developer. Reviewer 3 is
a Software Engineering researcher with knowledge in sound FLOSS and Software
Engineering practices.

From a reduced sample of 190 documents, Reviewer 1 and 3 worked independently
to evaluate title and abstracts by eligibility criteria. At the end of the
process, Reviewer 1 and Reviewer 3 compared their selection samples and found
31 conflicts. After discussing conflicts, they agreed to exclude eight from 31
conflicting decisions, converging on the exclusion of 129 studies by title
and abstract evaluation. Therefore, in the last step, we read the full text and
evaluated 61 documents, excluding 36 documents that do not meet the
eligibility criteria. Table~\ref{tab:exclusion} present the total of documents
excluded by each exclusion criteria.

\begin{table}[]
\centering
\caption{Results from each identification and screening phases}
\label{tab:exclusion}
\resizebox{\textwidth}{!}{%
\begin{tabular}{llr}
\hline
\rowcolor[HTML]{a6cee3} 
Exclusion criteria & Total \\ \hline
Duplicated & 41 \\ \hline
Scope of Publication & 677\\ \hline
Title out of context: Linux kernel project or FLOSS is not subject of study & 173 \\ \hline
Restricted to technical issues & 14 \\ \hline
Linux kernel is not subject of study & 66  \\ \hline
Restricted to validate a method, framework or tool & 22 \\ \hline
Linux kernel development practices is not subject of study & 63 \\ \hline
\end{tabular}%
}
\end{table}

From this process, we selected 25 documents for content analysis.
Table~\ref{tab:slr_selection} shows the distribution per
database of documents retrieved by each search engine and documents selection after
the screening phase.

\begin{table}[]
\centering
\caption{Selection process per database}
\label{tab:slr_selection}
\resizebox{0.6\textwidth}{!}{%
\begin{tabular}{llll}
	\rowcolor[HTML]{c0d6e4}
	\hline
Database & \# of hits & \# selected studies \\ \hline
IEEExplore & 96 & 2 \\
ACM Digital Library & 335 & 9 \\
Science Direct & 203 & 5 \\
Springer & 447 & 9
\end{tabular}%
}
\end{table}

The entire selection process is documented in
spreadsheets\footnote{Data available on \url{https://gitlab.com/ccsl-usp/glr/-/blob/master/SLR_Linux_kernel_development_model.ods}}. Each column
corresponding to a screening phase, where we detail reasons for exclusion.
Whenever we could assess that a single eligibility criterion failed, we
excluded the document: marked as excluded in the respective phase (column) and
reported this criterion.

\begin{table}[]
\centering
\setlength{\tabcolsep}{10pt}
\renewcommand{\arraystretch}{1.5}
\resizebox{\textwidth}{!}{%
\begin{tabular}{|lllll|}
\hline
\rowcolor[HTML]{a6cee3} 
Identifier and Reference & The use of Grey Literature & Multicase & Artifacts & Interview \\ \hline
SE1~\citet{Bagerzadeh2018} & Background and Research Design & No & Source code and Commits & No\\ \hline
SE2~\citet{Palix2014} & Introductory & No & Source code and Commits & No \\ \hline
SE3~\citet{Tan2019} & Analysis of Online Documents & No & Patches & No \\ \hline
SE4~\citet{Tian2012} & Background & No & Commits & No \\ \hline
SE5~\citet{Zhou2017} & Analysis of Online Documents & No & Source code & Yes\\ \hline
SE6~\citet{Rigby2014} & Shallow & Yes & Patches & Yes \\ \hline
SE7~\citet{Izquierdo2018} & Analysis of Websites & Yes & - & No \\ \hline
SE8~\citet{Jiang2014} & Introductory & No & Patches and Commits & No \\ \hline
SE9~\citet{Izquierdo2017} & Background & Yes & Patches and Commits & No \\ \hline
SE10~\citet{Zaidenberg2015} & Introductory & No & Source Code & No \\ \hline
SE11~\citet{Lindberg2014} & Analysis of Websites & Yes & - & No \\ \hline
SE12~\citet{Shaikh2017} & No & No & E-mail & No \\ \hline
SE13~\citet{Avelino2018} & Background and Discussion & Yes & Commits & No \\ \hline
SE14~\citet{Feitelson2012} & Analysis Online Documents & No & Source code & No \\ \hline
SE15~\citet{Israeli2010} & Discussion & No & Source code & No \\ \hline
SE16~\citet{Berger2014} & Analysis of Online Documents & Yes & Source code & No \\ \hline
SE17~\citet{Riehle2012} & Analysis of Websites & Yes & - & Yes \\ \hline
SE18~\citet{Barr2012} & Analysis of Online Documents & Yes & Source code and Commits & Yes \\ \hline
SE19~\citet{Lotufo2010} & Background & No & Source code and Commits & No \\ \hline
SE20~\citet{Forrest2012} & Background and Discussion & Yes & E-mail & No \\ \hline
SE21~\citet{Eyolfson2014} & Shallow & Yes & Commits & No \\ \hline
SE22~\citet{Capiluppi2013} & No & No & Commits & No \\ \hline
SE23~\citet{Joblin2017} & No & Yes & Commits & No \\ \hline
SE24~\citet{Bettenburg2015} & Analysis of Online Documents & Yes & Source code and E-mail & No \\ \hline
SE25~\citet{German2016} & Background & No & Commits & No \\ \hline
\end{tabular}%
}
\caption{Selected papers}
\label{tab:slr_selectedpapers}
\end{table}

As summarized in Table~\ref{tab:slr_selectedpapers}, we identified the data source
considered for investigation, whether a study includes or not grey
literature, and how this literature is used in each selected study.
Twelve studies use the Linux kernel project as the
unique case of study, and the remaining thirteen analyze and compare the Linux kernel
with other FLOSS projects. Most primary studies resort to grey materials to
obtain some background to conduct their investigation and discuss findings.
Six from 25 selected papers include the analysis of grey documents as sources
of evidence, but none of them collected these documents with a systematic
approach.

We observed that most selected studies resort to grey literature to develop
their investigation background, commonly in a non-systematic manner and
shallow analysis of data.
\citet{Bagerzadeh2018} massively used GL to support the investigation
background and research design, but do not use these documents for data
collection.
\citet{Zhou2017} inspect Linux websites looking for project-related
information and examine various blogs, forums, webzines, and news websites to
understand maintainer behavior and design suitable measures for maintainers'
work. However, the paper presents shallow information on their approach to
collect and analyze this kind of data.
\citet{Tan2019} collected and analyzed online documents to understand
communication when submitting patches in the Linux kernel development process.
They use an exploratory approach, searching two keywords on Google search,
gathering the first 50 hits and, from them, snowballing documents.

All selected studies consider at least one type of project artifacts. Most
of them collected data from source code repositories (18 studies), which could
include source code (10 studies) or commit messages (12 studies). Seven of them
analyzed data from mailing list archives. Finally, four studies
used project profiles and websites to collect data.
Ten studies used more than one data source in their analysis. Besides project
artifacts and public project documents, other sources of data used by primary
studies include questionnaires and interviews. None of them systematically
analyzed data from grey literature. However, we verified in the sample of
primary studies GL references that matched GL documents selected in our
previous phase of GLR.

%% ------------------------------------------------------------------------- %%
\subsection{Content Analysis}
\label{sec:mlranalysis}

We followed a directed approach of content
analysis~\citep{hsieh2005} to compare labels in the mind map from the GLR with
the content present in academic publications for the same period and similar
eligibility criteria.

\begin{figure}[ht]
  \centering
  \begin{subfigure}{.5\textwidth}
  \centering
    \includegraphics[width=0.9\linewidth]{figure/WordCloud_GLR_final_grey.png}
  \caption{Grey Literature Review- Word Cloud (Figure~\ref{fig:GLRcloud})}
  \label{fig:GLRcloudgrey}
  \end{subfigure}%
  \begin{subfigure}{.5\textwidth}
  \centering
    \includegraphics[width=0.9\linewidth]{figure/WordCloud_SLR.png}
  \caption{Systematic Literature Review - Word Cloud}
  \label{fig:SLRcloud}
  \end{subfigure}
\end{figure}

For comparison with GLR keywords, we generated a word cloud from the text data
of all documents selected from SLR, as presented by Figure~\ref{fig:SLRcloud}.
The word cloud enabled us to promptly note convergences and divergences of
interest between these two sources of evidence.
Both discuss key concepts of the project development model. They present
keywords that describe the basis of Linux development, such as time, community,
mailing list, developers. Other words describe project artifacts, such as code,
patch/change, source project, and repository.

On the one hand, the grey literature focuses on community
subjects, such as people, maintainers, discussion, conferences, code of
conduct, proper names of well-known profiles, and emphasizes the subsystem
organization. On the other hand, and as expected, the formal Software
Engineering literature shows keywords regarding process subjects, such as
coordination, metric, decision, organization, communication, size, author, and
fault. Consequently, comparing both states of mapped concepts strengthened our
previous decision to focus on the community model that supports the Linux
kernel development.

We started the directed content analysis by highlighting all passages in the
text that appears to be related to aspects of the Linux kernel development
community. We coded these passages considering codes predetermined by GL and
gave a new code to the text fragment that could not be categorized using the
initial GL coding scheme. Hence, we could support findings from the previous
phase and determine the relationship between each keyword's theory and practice.

Researchers are more likely to find evidence supporting the preexistent theory
by using directed content analysis~\citep{hsieh2005}. However, in our experience
from the grey literature to the formal ones, we identified gaps and mapped
divergences of understanding related to the project development and primary
concerns. Moreover, by opting for grey literature first, our researchers were
not blinded to social and contextual aspects that mobilize the community to
structure and restructure the project development process and organization.

%% ------------------------------------------------------------------------- %%
\section{Unifying Academic and Community Understandings}
\label{sec:slr_result}

This phase's primary goal is to identify which variables of interest in the
Linux kernel community publications were already explored or are under
investigation by Software Engineering studies. We also intend to understand how
they were addressed to identify which of them potentially need further
investigation. Therefore, we obtained the codes by directed content analysis of
the primary studies. We used the complete version of the grey literature mind
map\footnote{Mindmap available on
\url{https://gitlab.com/ccsl-usp/glr/-/blob/master/Linux_KernelDevelopment_Comunity_Full.pdf}}
as the initial code scheme. This version includes attributes and categories
emerged by reviewing community publications. Whenever the same code occurrence
is found, we evaluated whether the study's topics go through the entire branch
or has an unclear base or shallow approach.

We mapped all codes from our SLR in the GLR mind
map presented in Chapter~\ref{cap:linuxdevmodel}. This mapping describes how
well topics in the primary studies fit the selected community publications. We
present the comparative map divided according to the subjects
in Figures~\ref{fig:feature_comp}, ~\ref{fig:ecosystem_comp},
~\ref{fig:dev_comp}, ~\ref{fig:concerns_comp}. 
The comparative mind map highlights three levels of Software Engineering
studies coverage regarding FLOSS community topics: unclear (no-mention), some
discussion but shallow analysis, or addressed (investigated with findings).

In the following subsections, we relate the concepts by analyzing 108
publications from the Linux kernel community with those present in 25
academic studies selected in this systematic literature review. Due to the 
figures' size, a better understanding of the following section requires the
reader to consult mentioned figures while reading. As an alternative the
entire mind map is available online in a git respository\footnote{Comparive
mindmap available on \url{https://gitlab.com/ccsl-usp/glr/-/blob/master/Linux_KernelDevelopment_Comunity_Categories.pdf}}.

\subsection{General Characteristics of the Linux kernel Community}

In community publications, authors resort to analogies to describe the Linux
kernel development structure. Despite subjectivity, we can relate the
structures and meanings of an analogy in similar definitions, but more formal
and standardized in FLOSS academic studies. Therefore, in
Figure~\ref{fig:feature_comp}, we compare grey and academic literature on
topics of interest regarding the Linux kernel development community's general
characteristics.

\begin{figure}[H]
  \centering
    \includegraphics[width=1.0\linewidth]{figure/characteristic_comp.png}
  \caption{Comparing interests of academia and community publications -- General Characteristics}
  \label{fig:feature_comp}
\end{figure}


We observed that studies have explored the chain of trust in the
maintainers' tree and between maintainers and developers~\citep{Rigby2014,
German2016, Zhou2017}. 
\citet{Shaikh2017} exposes how chain-of-trust mechanisms are adopted to
reinforce authority and privileges in the Linux development community.
\textit{``Technology is often embedded with rules and structures that are seen
as part of good design and requirements, yet in practice, users are less able
to notice such rules unless they face them as a possible restriction in use.
Oligarchic recursion established the powerful actors and further entrenched
them into the Linux project through instituting nested and recursive practices
for code approval, shortlisting of patches or developers for different roles,
or the choice of new maintainers.''}
\citet{German2016} describe the patch flow into the
mainline by commits propagation via pull requests. They focus on the history
traceability across distributed repositories and state that \textit{``most
repositories are controlled by one person who has the ultimate power to decide
what makes it into that repository''}.

On the other hand, no primary study has addressed
the use of signature keys on pull requests as an identity verification
mechanism for security. Also, studies present few attributes to describe
social aspects and characterize community organization's overview. Finally,
discussions of the impacts of project culture on members' interaction and
development collaboration between subsystems are shallow.

\subsection{The Community Ecosystem}

The entities that compose the Linux kernel community are sources of interest
for academic studies and community publications. In general, we observed a good
coverage and convergence in these topics comparing both grey and formal
bibliographic literature, as shown in Figure~\ref{fig:ecosystem_comp}. 

\begin{figure}[ht]
  \centering
    \includegraphics[height=1.0\textheight]{figure/ecosystem_comp.png}
	\caption{Comparing interests of academia and community publications -- Attributes regarding the Community Ecosystem (1)}
  \label{fig:ecosystem_comp}
\end{figure}

Recent studies have investigated the
project structure to support coordination and governance. We found studies on
the Linux kernel project that analyze and compare their findings with
some particular characteristic of a bazaar-like model.
\citet{Lindberg2014} claim the Linux kernel project is an example of a
cathedral-like development model, with an oligarchic social distribution
\textit{``where important knowledge is controlled and shared by several core
developers, but where knowledge and control are highly concentrated and only
part of them extend to the entire community''}.  Despite knowledge restriction,
the structural kernel distribution has a high level of interpretative
flexibility since the community has \textit{``more freedom in how they combine
and utilize heterogeneous artifacts while developing OSS projects''}.

On the other hand, \citet{Joblin2017} investigate developer-coordination on 18
large FLOSS projects, including the Linux kernel, and found a hybrid coordination
structure between core and peripheral groups of developers.
\citet{Shaikh2017} present even more diversified characteristics for the Linux
governance. They gathered data from the \textit{Linux kernel Mailing List
(LKML)} to examine the coordination process along with the project history
until the adoption of git (2005). As a result, they described project
governance under continuous transformation. The community sampled different
version control tools to support the dramatic and sustained growth in numbers
of developers and contributions. Along with the project history, different
combinations of four management processes co-existed: autocratic clearing,
oligarchic recursion; federated self-governance; and meritocratic idea-testing.
For them, this multiplicity of authority structures embraces the diverse
motivations of different sorts of developers in large-scale, distributed FLOSS
projects such as the Linux kernel. 

Software Engineering studies have explored project artifacts on version control
tools and mailing lists as data sources regarding coordination and
communication. 
\citet{Avelino2018} describe the nucleus of collaboration and
discussion between Linux kernel authors by analyzing the authorship across
files of 66 stable releases.
\citet{German2016} analyze how Linux uses git and emphasize that \textit{``git
provides the freedom to participate in the development, but git does not
provide the freedom to contribute.''}.
To \citet{Shaikh2017}, \textit{``the distributed
nature of collaborating entails a greater dependence on such coordination tools
such as email and version control software''}.

In fact, the Linux kernel development is mostly e-mail driven, where
contributions and reviews take place in patches sent to mailing-lists.
\citet{Tan2019} map accepted and rejected patches sent to \textit{LKML} to
obtain sound practices for communication when submitting patches.  The mailing
list is a common data source for analyzing the review process.
\citet{Rigby2014} identify patch contributions on the mailing list by examining
threads looking for diffs. They consider patches that received a response to
analyzing the review processes of the Linux kernel and 24 FLOSS projects.
\citet{Jiang2014} perform an empirical study on patches sent to the Linux
kernel mailing list and trace the related commits to characterize the reviewing
history in a low-tech reviewing environment.
\citet{Izquierdo2017} analyze and propose a methodology to study Linux-style
code review. They say, in the Linux-like development model, developers from
many different companies collaborate to maintain a common code base. In this
sense, \citet{Forrest2012} explore the participation of outside organizations
in the FLOSS project. They selected the Linux kernel and GCC projects because
they use complete e-mail addresses in Bugzilla and code repositories and had
open and widely available mailing list archives.

As mapped from GL, outside organizations are part of the Linux community
ecosystem.
\citet{Riehle2012} analyze the structure and processes of Linux
Foundation and eight other FLOSS foundations. They model foundations categories
in terms of general characteristics, philosophy, intellectual property,
governance, financing, and operations. \citet{Izquierdo2018} analyze the nature
of 89 software foundations, and characterize more than 60 FLOSS Foundations to
describe the role of these foundations in FLOSS projects. Among the Linux
kernel-related, they selected the X.Org Foundation to study their
openness and influence in the development practices. However, they did not
focus on the Linux Foundation (LF) because it did not obey their eligibility
criteria of independence. They assess the LF \textit{``follows a flexible
approach which serves as an umbrella for its projects, which can deploy
specific development processes, and therefore concentrates more on the
promotion of OSS benefits.''}

\citet{Forrest2012} use different metrics
tracking participation and influence in projects to analyze whether businesses
and other organizations are biased in their participation. They search for
evidence of participation bias in terms of bug reporting and code
contributions and claim that \textit{``This knowledge is not just important
to the projects themselves, but to potential FOSS adopters or developers.
Understanding who supports and influences the project is crucial to making
better decisions about whether this is a project worth investing in.''}
Although they stated that \textit{``The responsibility for managing FOSS
projects is in the hands of project maintainers. These individuals manage the
code; they are responsible for choosing which contributions to incorporate
into a release, and who has the ability to submit code''}, none of the
selected studies explore the influence of the foundations and companies'
interests in the level of maintainership and project governance, as inferred
by GL documents.

Finally, members' communication still deserves further examination. The lack of
good social communication skills between members may spill over the
collaborative work that supports a distributed, community-based development and
negatively impacts the community's sustainability and growth.
\citet{Capiluppi2013} analyze commit-date and timestamp on git to assess
developers' activity patterns, and \citet{Eyolfson2014} address developers'
timezone to investigate code quality and the propensity of bug introduction.
None of the primary studies examine how timezone differences may affect
collaborative work and address the nucleus of collaboration in different
communication means. Besides mailing-lists, community interactions occur in
more informal and instantaneous venues, such as IRC and in-person meetings as
conferences. \citet{Tan2019} state that \textit{``for patch submission in the
Linux kernel, the medium is fixed: email. Thus, it is important to explore how
a message is expressed and what the context is''}. However, our findings on GLR
show that other communication venues are a good source of the project
decision-making process in the daily maintainership tasks of patches review and
acceptance and a broad perspective of governance.

\begin{figure}[ht]
  \centering
    \includegraphics[height=1.0\textheight]{figure/ecosystem_developers_comp.png}
	\caption{Comparing interests of academia and community publications -- Attributes regarding the Community Ecosystem (2) -- Developers}
  \label{fig:dev_comp}
\end{figure}

The GLR briefly cites individuals' profiles unrelated to the code's
contributions: internship coordinators, writers, users, and testers. Although
the selected studies address only users and testers, \citet{German2016} uncover
activities that were before invisible and detail three active end-users roles.
Their contributions do not involve code commits into the mainline: integration
testers, experimenters, product-line maintainers. They also divide code
contributors into two roles concerning mainline contributions: producers and
integrators.

Figure ~\ref{fig:dev_comp} continues to describe community profiles, focusing
on code developers.
In the hands-on perspective of coding and review, Software Engineering studies
and community publications use common characteristics to describe Linux kernel
developers. \citet{Avelino2018} use the e-mail address to identify unique
developers and \citet{Forrest2012} mapping e-mail domains to assess
contributions regarding contributors affiliation.

Community publications usually focus on long-term members, addressing what
motivates a developer to stay, what kind of motivation led them to join the
project, and whether their interest was satisfied or if their interest has
undergone changes. On the other hand, software engineering studies usually
investigate the motivations and barriers of less experienced kernel
developers. Moreover,
these studies tend to view new joiners as volunteers with personal interests
and who need to deal with inclusion barriers independently.
For \citet{Forrest2012}, \textit{``Large projects may not be accurately
portrayed as grass-roots volunteer efforts.''} Therefore, further studies may
investigate why developers decide to stay in the community or drop out and
whether barriers and motivations could change depending on how this new
contributor was introduced in the community and its affiliation.

Finally, few studies examined the maintainership structure or the coexistence
of different maintainership models in the Linux kernel project.
\citet{Zhou2017} already claimed that \textit{``Even though a substantial body
of literature has characterized developers' work, what maintainers do has not
been addressed''}. Their initiative to understand maintainership scalability
analyzes data from software engineering literature, online documents,
interviews, and mainline repository to quantify maintainers' work. Their study
slightly reports different maintainership structures in the Linux kernel;
however, no primary study explores those models.

\subsection{The Community Concerns}

\begin{figure}[ht]
  \centering
    \includegraphics[height=1.0\textheight]{figure/concerns_comp.png}
	\caption{Comparing interests of academia and community publications -- Attributes regarding Community Concerns}
  \label{fig:concerns_comp}
\end{figure}

Recent studies have already evaluated some current concerns in the Linux kernel
review process. The community is looking for mechanisms to grow the review
capacity and encourage developers' code reviews other than maintainers.
\citet{Bettenburg2015} shows that peer review in the Linux kernel is organized
less formally and follows a hierarchical approach. These characteristics affect
the transparency and documentation of the decision-making process. Because of
the voluntary management based on e-mails, the first feedback usually takes a
significant amount of time to happen. Moreover, contributions are either
abandoned, rejected, revised, or accepted.

\citet{Rigby2014} state that\textit{``earlier research into the optimal number
of inspectors has indicated that two reviewers perform as well as a larger
group''}, in contrast to the Linus' law.  \citet{Palix2014} also weigh
the accuracy of the law, since \textit{``in practice, code that is frequently
executed, or at least frequently compiled, is more likely to be reviewed than
the rest.  When code is frequently executed, many users are likely to encounter
any faults and some may fix the faults themselves or submit a request that the
faults be fixed by a kernel maintainer. When code is frequently compiled, even
if it is not frequently executed, it can easily be submitted to fault-finding
tools that are integrated with the kernel compilation process.''}
\citet{Izquierdo2017} shows the impact of the number of reviewers in the
time-to-merge metric for a Linux-like code review process. They also point out
the community should overcome the challenges of a low-tech review environment
and many e-mail messages to improve the project review process.

Also related to code review, the primary studies approach the double-standard
in patch acceptance. \citet{Palix2014} show that committers (maintainers)
generally present lower faulty commits proportionally for all their commits,
but their faulty patches are still applied in the repository.
\citet{Tan2019} reveals that patches sent by maintainers have more chance of
acceptance, even with poor commit description and explanation, because
reviewers tend to trust and predict quality. They also found that reviewers are
stricter with cleanup patches than with bug fixes and more likely to accept
changes previously discussed or a community need.
\citet{Bettenburg2015} observed a statistically significant acceptance bias
towards more substantial contributions.
\citet{Jiang2014} states that \textit{``Having to submit additional patch
versions is not a disaster, since relatively more such patches are accepted
than for patches with just one version, and reviewers keep on being interested
in subsequent versions.''} However, in some community publications, authors
suggest a limit between real improvements and proof of subordination in
repeated rejections.  Also, for \citet{Shaikh2017, Lindberg2014}, the processes
of code review and patch acceptance in the Linux kernel are mechanisms for
decision-making that strengthen privileges to the small group of kernel
maintainers.

\citet{Avelino2018} discuss how knowledge restriction affects the recruitment
process for core and architectural parts of the Linux kernel system, as
\textit{``developers must have great confidence on the changes they propose,
discouraging volunteers from performing small changes as a means to become
kernel contributors.''} \citet{Zhou2017} also state that core modules require
a higher skill level and people specialized and more experienced. In contrast,
implementation in peripheral modules is relatively self-contained, providing a
lower entry barrier for newcomers. Also, periphery parts keep growing because
of hardware manufacturers' interest, where commercial entities add code to the
driver's module and leave the community to resolve conflicts in core modules.
Consequently, their studies found less development activity in core modules
and stable maintainer's workload, while both continue to grow in the periphery.

\citet{Bagerzadeh2018} do not address much about community. On the other hand,
they discuss how to improve the community development process in the system
calls field with knowledge sharing via documentations and automated testing
and refactoring tools. \citet{Zaidenberg2015} also claim that existing tools
are not sufficient to detect kernel security vulnerabilities and present a
framework for kernel profiling, code coverage, and simulations during the
development, similarly to a debugger.  \citet{Tian2012} propose an approach to
automate bug-fixing patches identification to support maintainers of long-term
stable versions and \citet{Palix2014} claim for the relevance of fault-finding
tool and checkers to ensure code quality.

From Figure~\ref{fig:concerns_comp}, we can quickly realize that software
engineering studies address few topics that currently concern the community
about its development model. Our multivocal literature review suggests shallow
investigation in social challenges of members' conduct issues in a large-scale,
distributed community of developers. Also, the selected papers do not examine
issues related to active developers with less external notoriety. Evaluating
the inclusion of mid-level maintainers instead of more maintainers in the same
level may address scalability for maintenance and review processes. Also, we
could not find power assessment for internship programs and mechanisms to grow
developers into maintainers and make them able to replace upper-cadre members,
or if there are any non-explicit barriers to this.

%% ------------------------------------------------------------------------- %%
\section{The Third Perspective - Participant-Observation}
\label{sec:mlr_discussion}

%% Usar mais I na seção
We conducted an Multivocal Literature Review considering community publications and software engineering
studies on FLOSS to answer
\textit{RQ1. How do software engineering studies and Linux community publications describe the current Linux development community model?}
The comparative mind map presented and discussed in Section~\ref{sec:slr_result}
answers \textit{ RQ1.2. Do Software Engineering studies already cover these topics?}
In this section, we enrich the discussion on MLR findings with data from
a participant-observation that I conducted in communities of two Linux kernel subsystems, IIO and
DRM. The triangulation aims to produce a solid discussion of our findings to
more effectively answer 
\textit{RQ3. What are the possible gaps and opportunities for academic research in FLOSS development topics?}

During the content analysis of grey literature, we decided to restrict the
study scope to focus on the Linux Kernel Development Community. We made this
decision because we could evaluate a good saturation and systematization of the
concepts related to the Linux kernel development processes after the first
round of GLR coding. Also, the Linux kernel community presents a good
description of the main community's artifacts produced and delivered during the
development and release processes.

We ratify this assessment by analyzing content from formal literature. On the
one hand, we observed that software engineering studies reference some of the
same grey documents to describe those elements. A good example is the text
fragment from \citet{Izquierdo2017}, \textit{``All this process, since when a
patch series is posted for first time to the mailing list, until when it is
accepted to be committed is what we will refer to as the ``code review
process'' for that specific patch series. The full process is described for
developers in the Linux kernel documentation, section `Submitting Patches'.''}
On the other hand, most of the selected studies converge on
describing development processes, such as the Linux kernel patch flow, code
review process, and the release process (mainline and stable versions).

The Linux kernel project has inspired \citet{Raymond1999} to define
the Bazaar model of software development management. However, both selected community
publications and primary studies dissociate the current project from those
characteristics described more than two decades ago as open-source project
management standards. \textit{``Importantly, Linux’s development defies common
management theory [..]. At the same time, it does not fit into
any common software lifecycle model''}~\citep{Feitelson2012}. \textit{``The
Linux community is a pyramid''}~\citep{lf_blog}
and the Linux kernel project is governed by dictatorship, and patches are passed
up a ``chain-of-trust'' to the dictator~\citep{Rigby2014}.
The more the community grows, the more hierarchical it becomes. \textit{``A
number of subsystems are growing to the point where there needs to be some
overall higher-level coordination. So there are more two and three-level
trees than there used to be''}~\citep{lwn_patchflow_2017}.
In short, current studies and community publications do not resort to
attributes regarding anarchy or flatness to describe the state of the Linux
kernel development model.

My participant-observation in the Linux kernel community brought a third view
on the findings from literature. 
The benefits of including this qualitative
data collection method are twofold: expanding knowledge on characteristics
of the community under investigation and capturing nuances and unspoken rules
on Linux kernel development. We assumed that some social aspects that shape 
the Linux kernel development model are undocumented or appears only eventually.
Therefore, the field research could reveal these elements present in the daily
tasks of development, maintainership and mentorship of active members.

The knowledge gained from this community engagement work is further detailed
in Appendix~\ref{att:getinvolved} and Appendix~\ref{att:contribDRM}.
The community immersive work and data collection process lasted 15 months
(not sequential). However, once the investigation has completed, I continue
to be part of the community and participating in activities related to
development and maintenance.

In participant observation, the first observer task is to become a member of
the community under investigation. To join the development community
around a Linux subsystem, I, as a participant-observer, developed specific
technical and non-technical skills to contribute to the project. 
This learning process started with a training phase on developing device
drivers and sending patches to the IIO subsystem.
The approach adopted in this research for training activities comprised of:
\begin{enumerate}
\item \textit{Development environment setup} for coding and communication:
(1) choosing an easier e-mail client to send patches; (2) using a bouncer to
stay connected on IRC community channels; (3) identifying the maintainer's
repository to contibute to a specific Linux kernel subsystem; (4) using a
virtual machine and be able to modify, compile, install and test customized
kernel versions. 
\item \textit{Learning development and release process}: how to patch and send
contributions through subsystem mailing-list; checking code style rules;
understanding the contribution flow.
\item \textit{Getting involved}: sending code clean-up changes; examining
staging drivers debts and sending improvements and bug fixes.
\end{enumerate}
For this, I resorted to tutorials and also integrated the
FLUSP (FLOSS at USP)\footnote{\url{https://flusp.ime.usp.br}}. FLUSP is an extension
group of the University of São Paulo (USP) created to foster student participation in
FLOSS projects.

To become part of the group of community developers and
understand the contribution workflow (submission, revision, acceptance, and
merge), I developed a total of eight patches to the
selected subsystem community, Industrial I/O. A summary of these contributions is
presented in Appendix~\ref{att:getinvolved}. 
In the Linux kernel project, code, comments, reviews and other discussions use
the same route: emails in the mailing list. Therefore, each code contribution sent
to the mailing list can be considered a core of interaction between developers.
Linus subsystem mailing lists are open and publicly available on the Internet, all
contributions and e-mails were collected as data sources to identify members, roles
and how interactions happen in the Linux kernel development community.
I also took notes and wrote blog posts
describing each cycles of contribution, lessons learned, and
reflections\footnote{\url{https://melissawen.github.io/blog/2019/04/10/first-patch-linux}}.

Continuing my immersive work, I moved to a subsystem with a larger community of
active contributors, the kernel DRM/GPU subsystem (DRI/DRM).
Even being in the same project, each subsystem requires from the developer a
specific computer knowledge base in terms of software and hardware. Besides the
transition between operating system components, I needed to understand other
specifications and testing tools for the drivers in the GPU subsystem.

I could experienced different community roles in this
phase. Each role brings a specific
perspective of the development process and different levels of interaction with
other members.
During one year, I walked a path in the community as:
\begin{itemize}
\item Linux/DRM development community newcomer;
\item Google Summer of Code intern;
\item Virtual KMS driver maintainer;
\item Outreachy internship program mentor
\end{itemize}

I sent a total of 15 patches with different complexity of code contributions:
code style, bug fixes, maintainability improvements, test coverage, operational
behavior fixes, and new features. I reviewed 10 patches for DRM subsystem drivers.
I posted 12 blog posts to describe my participation in the subsystem community.
In addition to this involvement in more technical activities, maintainership and
mentorship required more social skills, such as, working in a careful speech,
building a follow-up routine, understanding the other side perspectives,
attention to conduct issues.
The participant observation in DRM/Linux community is detailed
in Appendix~\ref{att:contribDRM}. I also present discussions about the community
joining phase, the difficulties experienced, and some reflections in the face of
particular situations.


%% ------------------------------------------------------------------------- %%
\subsection{Mapping gaps in academic and community publications}
\label{sec:gaps_tp}

Interestingly, grey and formal literature converge many times in carrying
unclear information about Linux kernel software. In both samples of selected
documents, we could find authors describing the software as an Operating System
(OS) instead of an OS kernel. In other words, \textit{``Linux is the
kernel: the program in the system that allocates the machine's resources to
the other programs that you run. [..] The ambiguous use of the name doesn't
help people understand.''}
\footnote{\url{https://www.gnu.org/gnu/linux-and-gnu.en.html}}

Some selected studies define the Linux project modularization based on
directories and files, while community publications prefer to use the
subsystems organization. In academic studies, statistics are grouped by year
%tem um motivo, tem que procurar nos papers (eu li e esqueci)
while community publications present data by kernel release.
For \citet{Avelino2018}, investigation at the subsystem level
\textit{``requires a reference architecture of the Linux kernel, as well as a
mapping between elements at the source code level to elements in the
architectural model.''} Therefore, out of the typical approach in directories
and years, they \textit{``use the mapping rules set by Greg Kroah-Hartman, one
of the main Linux kernel developers''} and available in his repository as
scripts\footnote{\url{https://github.com/gregkh/kernel-history}} to map files in
each subsystem and different kernel releases. The logs and scripts in his
repository is explicitly the same used by the Linux Kernel Development Report 2012 by
Linux Foundation.
%acm209
%eles investigam os dados por ano
%=> a comunidade costuma investigar por release
%eles definem a modularização inicialmente com base na estrutura de arquivo;
%depois eles definem como o conjunto de arquivos mantidos por um mesmo mantenedor
%=> comunidade fala de subsistema
% acm140
% "Figure 24 shows the number of authors and committers associated with the patches included in each version, both in total and broken down by directory."

We also find divergences in study findings and community claims. While
maintainers have frequently advertised through community publications signs of
stress, the selected study on maintainership scalability, \citet{Zhou2017} bring
another perspective about this concern. They investigated the kernel maintainer
activities and \textit{``found that the workloads of the average maintainer and
the median maintainer do not appear to increase, thus some risks hypothesized
in the community are not evident''}. Our participant-observation brings a third
point of view. The study has not considered that active developers and mainly
maintainers are usually employees from companies that do not pay them to work
exclusively for the kernel. Moreover, many of them have few opportunities to
upstream contributions under their employer's support. Consequently,
maintainership could be an extra work that contributes to boosting the career
and also increasing their workload.
%PARTICIPANT

In their work, \citet{Zhou2017} mentioned a community publication that we have also analyzed
in our GLR~\citep{lwn_maintainerscale}: \textit{``Linus Torvalds
said that he has come to like the group maintainer model, where more than one
person takes responsibility for a given subsystem. However, numerous developers
were skeptical of the idea''}. We have analyzed this document and its
snowballing references, and, from our understanding, the developers skepticism
is around the sufficiency of a model with two maintainers. In addition, Torvalds
has refused the idea of sharing commit-rights in the top-level maintainance.

After a participant observation in the Linux kernel project, we found
statements in the primary studies' that do not fit with practice. After more
than a year of involvement with the DRM subsystem community performing distinct
roles (volunteer, intern, maintainer, and mentor), I observed the developer
preference on sending patches that change only parts of the subsystem only to
specialized mailing-lists, and do not include the project-wide mailing list
\url{linux-kernel@vger.kernel.org} as recipient, see examples at
Appendix~\ref{att:contribDRM}. This practice diverges from the assumption of
\citet{Tan2019} to avoid obtaining duplicate patches for data collection,
considering that \textit{``In general, LKML contains all the patches because
the kernel community stipulates that the patches sent to those specialized
lists need to be copied to LKML.''}. Also, the Linux kernel
Documentation\footnote{\url{https://www.kernel.org/doc/html/latest/process/submitting-patches.html}}
states that \textit{``\url{linux-kernel@vger.kernel.org} functions as a list of
last resort, but the volume on that list has caused a number of developers to
tune it out.''}. In summary, \textit{``in addition to a project-wide mailing
list for overall discussion, there exist many subsystem-specific mailing lists.
Contributors are encouraged to submit their contributions through the
corresponding mailing list of the subsystem that their contribution
targets''}~\citep{Bettenburg2015}.

To overcome the data collection challenge in defining a unique developer
identity, \citet{Avelino2018} \textit{``first assign to a single developer all
commits with the same e-mail, but with different names''}. However, we found
examples in the subsystems community that show that alias approach is not
enough. The same person has more than one e-mail address, commonly
distinguishing personal and professional relationships by e-mail domain.
Moreover, the same person usually switches between personal and professional
e-mail addresses to grant the contribution copyright to an outside organization
that sponsors the work.
%=====> Not enough. Siqueira has to different e-mails, with the same name. Also others maintainers like danvet and jonathan, as Eduardo and Magali have checked in %their research on Grimore.

\citet{Avelino2018} claim that file authorship measures help identify
each file's key developers. This claim seems valid for developers who are still
active in the community. Nevertheless, some developers and companies do not
continue contributing, and the code ends up being maintained by other
developers. An example is the VKMS driver. I am currently co-maintaining it,
and one of the driver's authors decided not to continue working on the
community and have sent contributions for more than two years. From the
field research experience, identifying the file maintainers is more accurate
than authors. Another approach would be checking the number of lines by last
change authors using git commands, like git blame.
%In this context, authorship measures—like the DOA model used in this paper—can help to automatically identify the key developers of each file in a large open source %project."
%===> I disagree; I think, in general, identify the maintainers is more relevant than the authors, since many authors are not current and active developers. For %instance, the case of Haneen in the VKMS. Also checking the number of lines by last change authors (aka git blame).

\citet{Capiluppi2013} verified commit date and timestamp on git to assess
developers activity within the Linux Kernel during the day and the week. They
claim to carefully monitor activities on late night and after office time
slots since they are more likely to introduce additional complexity to the
project code. In this scenario, two issues deserve further investigation:
(1) communication means should be considered as a data source, and (2) code
contribution effort in high-complex changes is a long-term production.
Therefore, commit timestamp is a small piece of the work effort and would be
inaccurate data to determine when development happens.

Although the community claim that \textit{``developers who work on independent
projects tend to think of themselves as affiliated with the project first, and
their employer second; that results in a strong incentive to avoid
compromising the project's goals in favor of what today's employer
wants''}~\citep{lwn_linux25}, this neutrality or
care to the Linux kernel project is not clear. Some participants expressed the
desire to remain in the community when they leave their jobs but continuing as
a volunteer is not as frequent as it seems. On the other side, others have
expressed they are working in the Linux kernel project because it pays well,
and the skill brings professional recognition to high job positions.

\citet{Tian2012} warned of the challenges and cautions when using keywords for
collecting and mining patch data. For them, 
\textit{``All of these studies employ a keyword-based approach to infer commits
that correspond to bug fixes, typically relying on the occurrence of keywords
such as `bug' or `fix' in the commit log. Some studies also try to link
software repositories with a Bugzilla by the detection of a Bugzilla number in
the commit log. Unfortunately these approaches are not sufficient for our
setting because: 1) Not all bug fixing commit messages include the words
`bug' or `fix' [..]''}. \citet{Eyolfson2014} also point out the misuse of `fix'
keywords in the Linux and other two FLOSS projects investigated, and how false
positives affects precision and recall of their methods.
During participant observation, we observed the misuse of these keywords in
different situations: (1) in the training and insertion stage in the IIO
community, as a member of FLUSP; (2) in the internship for the DRM community,
as a patch reviewer. What has been observed is that new contributors use the
word fix to describe clean-up codes, legibility improvements, or debugging
messages. For bug-fix patches, the Linux kernel Documentation recommends that
\textit{``if your patch fixes a bug in a specific commit, e.g., you found an
issue using git bisect, please use the  `Fixes:' tag''}. The tag helps
determine the bug's origin, review a bug fix, and assist the stable kernel
team. Unfortunately, it is a recommendation that still depends on human
attention to ensure its employment.

Ultimately, the participant-observation in the Linux kernel development
community enables us to reinforce and discuss our findings with the
qualitative perspective.
In the context of large-scale FLOSS projects, we believe that becoming a member
of the studied community brings the researcher a better understanding of
undocumented rules and roles that shape development processes.
Uncovering these elements is relevant to conduct
and increase the quality of the research design and discussion of results.
Despite the reported challenges for GLR, we also argue that the use of GL
material is even more fruitful in FLOSS research, given the vast amount of
public information resources produced by the FLOSS communities.
In such a scenario, we claim that
researchers should investigate such resources before taking the time of FLOSS
contributors with surveys or interviews~\citep{Garousi2016}, especially
considering that \emph{i)} most of the needed information is already available
with rich details and \emph{ii)} top contributors usually do not have much time
for extensive interviews.


\subsection{Threats to Validity}

The Linux kernel software and its community-project have peculiarities
compared to other FLOSS projects. Linux is both a typical case of a successful
FLOSS project and an extreme case of vigor in the publications made by its
community. Due to the software type, its complexity, longevity, and project
community size, the Linux kernel is the topic of many publications. It has a
high availability of materials produced by practitioners, unlike many other
FLOSS projects. Therefore, obtaining information and performing some GLR steps
can vary in complexity when applied to other FLOSS projects' investigations.

On the one hand, the maturity and variety of market usage of the Linux kernel
project in the software industry increase the amount of information available
public and online. On the other hand, the Linux development process's
peculiarities and the community structure demands familiarity with FLOSS
practices to interpret the data. To expand this knowledge and increase the
accuracy in coding the data, a researcher should get closer to the community's
daily life, searching for complementary documents and observing the community
in practice.

This approach brings benefits but can lead to bias. Nevertheless, due to the
Linux project relevance and protagonism in the last two decades of FLOSS
research, an accurate mapping of its current state of development practices
could improve the execution and relevance of software engineering research on
FLOSS.
%%FALAR que a relevancia do linux para o método também é mencionada em outros papers?

%%-----
The Linux kernel development model was the case for three different methods of
qualitative data collection: grey literature review, systematic literature
review and participant-observation.
Although we followed a systematic approach to searching and selecting documents
for formal and gray literature, the differences in quality of the search tools
and vocabulary used by different audiences led to specific adaptations in each
review. Therefore, it was impossible to use the same document search and
selection protocol to review both kinds of literature.

We used the same time range and search-strings as close as efficient to select
108 documents from grey literature and 25 software engineering studies that
approach the Linux kernel development community's characteristics. Despite the
difference in number, most of the grey materials are brief texts, while the
selected studies have at least ten well-structured pages. After we have
analyzed both content, we considered to reach balanced sources of data,
notwithstanding the large difference in number would affect the diversity
information equilibrium.

We resorted to a multivocal literature review to highlight convergence and
divergence of interest by the state-of-the-art and state-of-the-practice in ten
years of Linux kernel development.
We considered ten years a reasonable time range of review. Our initial sample
began from thousands to 340 pre-selected grey documents, and 1081 search hits
in academic digital libraries.
Nevertheless, we believe that every open topic deserves more in-depth and more
centralized literature examination to assess Software Engineering studies'
coverage more accurately.

Finally, we use the qualitative method of participant-observation, aware of
the researcher's risk of bias. We also weighted the power of the inclusion of a
not usual perspective on Software Engineering studies on FLOSS. Therefore, we
considered that the benefits of understanding the concepts and expanding the
critical view on the study topics are superior to the risk of inserting a bias
intrinsic to a human researcher.
